## org.apache.lucene.search
Class ConstantScoreQuery.ConstantScorer

    java.lang.Object
      org.apache.lucene.search.DocIdSetIterator
          org.apache.lucene.search.Scorer
              org.apache.lucene.search.ConstantScoreQuery.ConstantScorer

Enclosing class:
  ConstantScoreQuery

    protected class ConstantScoreQuery.ConstantScorer

extends Scorer

Nested Class Summary

Nested classes/interfaces inherited from class org.apache.lucene.search.Scorer
`Scorer.ScorerVisitor<P extends Query,C extends Query,S extends Scorer>`

Field Summary

Fields inherited from class org.apache.lucene.search.Scorer
`weight`

Fields inherited from class org.apache.lucene.search.DocIdSetIterator
`NO_MORE_DOCS`

Constructor Summary
`ConstantScoreQuery.ConstantScorer(Similarity similarity, DocIdSetIterator docIdSetIterator, Weight w)`

Method Summary
`int` `advance(int target)` Advances to the first beyond (see NOTE below) the current whose document number is greater than or equal to target.
`int` `docID()` Returns the following: -1 or `DocIdSetIterator.NO_MORE_DOCS` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
`int` `nextDoc()` Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set. NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
`float` `score()` Returns the score of the current document matching the query.
`void` `score(Collector collector)` Scores and collects all matching documents.
`protected boolean` `score(Collector collector, int max, int firstDocID)` Expert: Collects matching documents in a range.

Methods inherited from class org.apache.lucene.search.Scorer
`freq, getSimilarity, visitScorers, visitSubScorers`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ConstantScoreQuery.ConstantScorer

    public ConstantScoreQuery.ConstantScorer(Similarity similarity,
                                             DocIdSetIterator docIdSetIterator,
                                             Weight w)
                                      throws IOException

Throws:
  `IOException`

Method Detail

### nextDoc

    public int nextDoc()
                throws IOException

  Description copied from class: `DocIdSetIterator`
  Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set.
  NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.

  Specified by:
    `nextDoc` in class `DocIdSetIterator`
  Throws:
    `IOException`

### docID

    public int docID()

  Description copied from class: `DocIdSetIterator`
  Returns the following:
  - -1 or `DocIdSetIterator.NO_MORE_DOCS` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
  - `DocIdSetIterator.NO_MORE_DOCS` if the iterator has exhausted.
  - Otherwise it should return the doc ID it is currently on.

  Specified by:
    `docID` in class `DocIdSetIterator`

### score

    public float score()
                throws IOException

  Description copied from class: `Scorer`
  Returns the score of the current document matching the query. Initially invalid, until `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` is called the first time, or when called from within `Collector.collect(int)`.

  Specified by:
    `score` in class `Scorer`
  Throws:
    `IOException`

### advance

    public int advance(int target)
                throws IOException

  Description copied from class: `DocIdSetIterator`
  Advances to the first beyond (see NOTE below) the current whose document number is greater than or equal to target. Returns the current document number or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set.

  Behaves as if written:

       int advance(int target) {
         int doc;
         while ((doc = nextDoc()) < target) {
         }
         return doc;
       }

  Some implementations are considerably more efficient than that.

  NOTE: when `target ≤ current` implementations may opt not to advance beyond their current `DocIdSetIterator.docID()`.

  NOTE: this method may be called with `DocIdSetIterator.NO_MORE_DOCS` for efficiency by some Scorers. If your implementation cannot efficiently determine that it should exhaust, it is recommended that you check for that value in each call to this method.

  NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.

  Specified by:
    `advance` in class `DocIdSetIterator`
  Throws:
    `IOException`

### score

    public void score(Collector collector)
               throws IOException

  Description copied from class: `Scorer`
  Scores and collects all matching documents.

  Overrides:
    `score` in class `Scorer`
  Parameters:
    `collector` - The collector to which all matching documents are passed.
  Throws:
    `IOException`

### score

    protected boolean score(Collector collector,
                            int max,
                            int firstDocID)
                     throws IOException

  Description copied from class: `Scorer`
  Expert: Collects matching documents in a range. Hook for optimization. Note, `firstDocID` is added to ensure that `DocIdSetIterator.nextDoc()` was called before this method.

  NOTE: Because of backwards compatibility, this method is still declared as protected, but it is intended to be public, because it's called from other classes (like BooleanScorer). If you subclass `Scorer`, you should declare the overridden method as public to ease transition to Lucene 4.0, where it will be public.

  Overrides:
    `score` in class `Scorer`
  Parameters:
    `collector` - The collector to which all matching documents are passed.
    `max` - Do not score documents past this.
    `firstDocID` - The first document ID (ensures `DocIdSetIterator.nextDoc()` is called before this method.
  Returns:
    true if more matching documents may remain.
  Throws:
    `IOException`